package de.dfki.sds.hephaistos.deeplink;

import de.dfki.sds.hephaistos.server.Server;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.rdf.model.ResourceFactory;

/**
 * Used to create ad-hoc resources and properties for hephaistos' ontology.
 * @author Markus Schr&ouml;der
 */
public class Ontology {
    
    public static final String uri = Server.HOST + "/ontology/";

    public static final Resource resource( String local )
        { return resource("hephaistos", local); }

    public static final Property property( String local )
        { return property("hephaistos", local); }
    
    public static final Resource resource( String name, String local )
        { return ResourceFactory.createResource( uri + name + "/" + local ); }

    public static final Property property( String name, String local )
        { return ResourceFactory.createProperty( uri + name + "/", local ); }
    
    //to indidcate that the cell has this instance created
    //domain=cell
    //range=instance
    public static Property hasInstance = property("hasInstance");
}
