package de.dfki.sds.hephaistos.deeplink;

import de.dfki.sds.hephaistos.server.Server;
import de.dfki.sds.hephaistos.storage.StorageManager;
import de.dfki.sds.hephaistos.storage.Utils;

/**
 * Is used in Project to have a path like /project/graph/1 .
 * @author Markus Schr&ouml;der
 */
public class RGraphSelector implements DLResource, FIChild {

    public static final String DEEPLINK = Server.HOST + "/" + Utils.PROJECT_SEG + "/" + Utils.GRAPH_SEG;
    
    public StorageManager storageManager;
    
    public RGraphSelector(StorageManager storageManager) {
        this.storageManager = storageManager;
    }
    
    @Override
    public DLResource child() {
        return new RMap();
    }

    @Override
    public DLResource child(String name) {
        return storageManager.getRDFGraphStorage(DEEPLINK +"/" + name);
    }
    
}
