package de.dfki.sds.hephaistos.deeplink;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class RMap implements DLResource, FIIndex, FIChild {
    
    private Map<String, DLResource> map;

    public RMap() {
        map = new HashMap<>();
    }

    public RMap(Map<String, DLResource> map) {
        this.map = map;
    }

    @Override
    public DLResource index(String indexStr) {
        int index = Integer.parseInt(indexStr);
        
        List<DLResource> list = new LinkedList<>(map.values());
        
        if(index < 0 || index >= list.size())
            throw new RuntimeException("index not found");
        
        return list.get(index);
    }

    @Override
    public String toString() {
        return "RMap[" + map.size() + "]";
    }

    @Override
    public DLResource child() {
        return new RMap(map);
    }

    @Override
    public DLResource child(String name) {
        return map.get(name);
    }

    public Map<String, DLResource> getMap() {
        return map;
    }

}
