package de.dfki.sds.hephaistos.storage.dsv;

import de.dfki.sds.hephaistos.storage.StorageSummary;
import de.dfki.sds.hephaistos.storage.StorageSummaryCache;
import java.util.Arrays;
import java.util.List;

/**
 * Calculates metrics about a delimiter-separated value table.
 * @author Markus Schr&ouml;der
 */
public class DSVStorageSummary extends StorageSummary {
    
    private DSVStorageSqlite storage;

    public DSVStorageSummary(DSVStorageSqlite storage, StorageSummaryCache cache) {
        super(cache);
        this.storage = storage;
    }

    @Override
    public List<String> prepare() {
        //calculate if absent
        getRowCount();
        //sorted metrics
        return Arrays.asList("row count");
    }
    
    public long getRowCount() {
        return cache.computeLongIfAbsent("row count", s -> storage.size());
    }
    
}
