package de.dfki.sds.mschroeder.commons.lang;

import de.dfki.sds.mschroeder.commons.lang.math.Interval;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class ListUtility {

    public static <T> List<List<T>> ngrams(List<T> source, Interval ns) {
        List<List<T>> ngrams = new ArrayList<>();
        for (int n : ns) {
            for (int i = 0; i <= source.size() - n; i++) {
                ngrams.add(source.subList(i, i + n));
            }
        }
        return ngrams;
    }

    public static <T> List<List<T>> chunks(List<T> bigList, int n) {
        List<List<T>> chunks = new ArrayList<>();
        for (int i = 0; i < bigList.size(); i += n) {
            chunks.add(bigList.subList(i, Math.min(bigList.size(), i + n)));
        }
        return chunks;
    }

    //https://stackoverflow.com/questions/10305153/generating-all-possible-permutations-of-a-list-recursively
    public static <E> List<List<E>> generatePerm(List<E> original) {
        if (original.isEmpty()) {
            List<List<E>> result = new ArrayList<>();
            result.add(new ArrayList<>());
            return result;
        }
        E firstElement = original.remove(0);
        List<List<E>> returnValue = new ArrayList<>();
        List<List<E>> permutations = generatePerm(original);
        for (List<E> smallerPermutated : permutations) {
            for (int index = 0; index <= smallerPermutated.size(); index++) {
                List<E> temp = new ArrayList<>(smallerPermutated);
                temp.add(index, firstElement);
                returnValue.add(temp);
            }
        }
        return returnValue;
    }

}
