package de.dfki.sds.mschroeder.commons.lang;

import java.util.Arrays;
import java.util.List;
import java.util.regex.Pattern;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class RegexUtility {
    
    public static String quote(String text) {
        //\.[]{}()*+-?^$|
        //<([{\^-=$!|]})?*+.>
        List<String> special = Arrays.asList(
                ".", "\\", "-", "{", "}", "[", "]", 
                "(", ")", "*", "+", "?", "^", "$", "|",
                "<", ">", "=", "!"
                );
        String escaper = "\\";
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < text.length(); i++) {
            String chara = String.valueOf(text.charAt(i));
            if(special.contains(chara)){
                sb.append(escaper);
            }
            sb.append(chara);
        }
        return sb.toString();
    }
    
    public static boolean isCompileable(String regex) {
        try {
            Pattern.compile(regex);
            return true;
        } catch(Exception e) {
            return false;
        }
    }

    public static String genAllCaseGap(String val, boolean gap) {
        val = val.toLowerCase();
        String pattern = "";
        for (int i = 0; i < val.length(); i++) {
            char c = val.charAt(i);
            String cstr = String.valueOf(c);
            String cstrup = cstr.toUpperCase();
            boolean hasUpper = !cstr.equals(cstrup);

            if (hasUpper) {
                pattern += "[";
                pattern += quote(cstrup);
            }
            pattern += quote(cstr);
            if (hasUpper) {
                pattern += "]";
            }

            if (gap && i < val.length() - 1) {
                pattern += ".{0,1}";
            }
        }
        return pattern;
    }
    
}
