package de.dfki.sds.mschroeder.commons.lang;

import java.time.LocalDateTime;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class TimeUtility {

    public static String millisToString(long millis) {
        long hours = TimeUnit.MILLISECONDS.toHours(millis);
        long minutes = TimeUnit.MILLISECONDS.toMinutes(millis) - (hours * 60);
        long seconds = TimeUnit.MILLISECONDS.toSeconds(millis) - ((hours * 60 * 60) + (minutes * 60));
        millis = millis - ((hours * 60 * 60 * 1000) + (minutes * 60 * 1000) + (seconds * 1000));
        
        StringBuilder sb = new StringBuilder();
        
        if(hours > 0){
            sb.append(hours + "h");
        }
        if(minutes > 0){
            sb.append(" " + minutes + "m");
        }
        if(seconds > 0){
            sb.append(" " + seconds + "s");
        }
        if(millis > 0){
            sb.append(" " + millis + "ms");
        } else if(sb.length() == 0) {
            sb.append("0ms");
        }
        
        return sb.toString().trim();
    }
    
    public static Calendar localDateTimeToCalendar(LocalDateTime localDateTime) {
        Calendar calendar = Calendar.getInstance();
        calendar.clear();
        calendar.set(localDateTime.getYear(), localDateTime.getMonthValue() - 1, localDateTime.getDayOfMonth(),
                localDateTime.getHour(), localDateTime.getMinute(), localDateTime.getSecond());
        return calendar;
    }
}
