package de.dfki.sds.mschroeder.commons.lang.data;

import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class Person {

    private String id;

    private String firstName;
    private String lastName;

    public Person() {
    }

    public Person(String id, String firstName, String lastName) {
        this.id = id;
        this.firstName = firstName;
        this.lastName = lastName;
    }

    public Person(String firstName, String lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
    }
    
    public Set<String> getNameSet() {
        //if set has same names the order does not matter: hashCode and equals works
        Set<String> s = new HashSet<>();
        if(firstName != null && !firstName.isEmpty()) {
            s.add(firstName);
        }
        if(lastName != null && !lastName.isEmpty()) {
            s.add(lastName);
        }
        return s;
    }
    
    public String getFullName() {
        return (firstName + " " + lastName).trim();
    }

    public void swap() {
        String tmp = lastName;
        lastName = firstName;
        firstName = tmp;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getFirstName() {
        return firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public String getId() {
        return id;
    }

    public boolean hasId() {
        return id != null && !id.isEmpty();
    }

    public void setId(String id) {
        this.id = id;
    }

}
