package de.dfki.sds.mschroeder.commons.lang.kb;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class KBClass extends KBResource {
    
    private List<KBClass> subClasses;
    private List<KBClass> superClasses;

    public KBClass() {
        this(null, null, null);
    }

    public KBClass(String uri, String prefLabel, String comment) {
        super(uri, prefLabel, comment);
        subClasses = new ArrayList<>();
        superClasses = new ArrayList<>();
    }

    public List<KBClass> getSubClasses() {
        return subClasses;
    }

    public List<KBClass> getSuperClasses() {
        return superClasses;
    }

    public void setSubClasses(List<KBClass> subClasses) {
        this.subClasses = subClasses;
    }

    public void setSuperClasses(List<KBClass> superClasses) {
        this.superClasses = superClasses;
    }
    
    @Override
    public String toString() {
    	return "(C) " + this.prefLabel + " <" + this.uri + ">";
    }
    
}
