package de.dfki.sds.mschroeder.commons.lang.kb;

import java.util.List;
import java.util.Objects;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class KBResource {
    
    protected String uri;
    protected String prefLabel;
    protected String comment;
    protected List<String> altLabels;

    public KBResource() {
    	this(null, null, null);
    }
    
    public KBResource(String uri, String prefLabel, String comment) {
        this.uri = uri;
        this.prefLabel = prefLabel;
        this.comment = comment;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    public String getPrefLabel() {
        return prefLabel;
    }

    public void setPrefLabel(String prefLabel) {
        this.prefLabel = prefLabel;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public List<String> getAltLabels() {
        return altLabels;
    }

    public void setAltLabels(List<String> altLabels) {
        this.altLabels = altLabels;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(this.uri);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof KBResource)) {
            return false;
        }
        final KBResource other = (KBResource) obj;
        if (!Objects.equals(this.uri, other.uri)) {
            return false;
        }
        return true;
    }
    
    @Override
    public String toString() {
    	return "(R) " + this.prefLabel + " <" + this.uri + ">";
    }
    
}
