package de.dfki.sds.mschroeder.commons.lang.math;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;

/**
 *
 * @author Markus Schr&ouml;der
 * @param <T>
 * @deprecated use MinAvgMaxSdDouble
 */
@Deprecated
public class MinAvgMaxSd {
    
    private int min = Integer.MAX_VALUE;
    private int max = Integer.MIN_VALUE;
    private int sum = 0;
    private int count = 0;
    private List<Integer> ns;
    private Histogram histogram;
    
    public MinAvgMaxSd() {
        ns = new ArrayList<>();
        histogram = new Histogram();
    }
    
    public void add(int n) {
        min = Math.min(n, min);
        max = Math.max(n, max);
        sum += n;
        count += 1;
        ns.add(n);//for variance
        histogram.add(n);
    }

    @Override
    public String toString() {
        return getCount() == 0 ? "no statistics b.c. count:0" : 
                "min:" + min + "/avg:" + String.format(Locale.US, "%.3f", getAvg()) + "/max:" + max + "/s.d.:" + String.format(Locale.US, "%.3f", getStdDev()) + "/sum:" + getSum() + "/count:" + getCount();
    }

    public static final List<String> METRICS = Arrays.asList(
            "min", "max", "sum", "count", "avg", "var", "stddev"
    );
    
    public double get(String name) {
        switch(name) {
            case "min": return getMin();
            case "max": return getMax();
            case "sum": return getSum();
            case "count": return getCount();
            case "avg": return getAvg();
            case "var": return getVariance();
            case "stddev": return getStdDev();
        }
        throw new RuntimeException(name + " not found");
    }
    
    public int getMin() {
        return min;
    }

    public int getMax() {
        return max;
    }

    public int getSum() {
        return sum;
    }

    public int getCount() {
        return count;
    }
    
    public float getAvg() {
        return sum / (float) count;
    }
    
    public float getVariance() {
        if(count <= 1) {
            return 0;
        }
        
        float mean = getAvg();
        float temp = 0;
        for(int a : ns)
            temp += (a-mean)*(a-mean);
        return temp / (float)(count-1);
    }

    public double getStdDev() {
        return Math.sqrt(getVariance());
    }
    
    public String toCSV() {
        return min + "," + getAvg() + "," + max + "," + getStdDev();
    }
    
    public String toCSVHeader(String prefix) {
        return prefix + "-min" + "," + prefix + "-avg" + "," + prefix + "-max" + "," + prefix + "-stddev";
    }

    public Histogram getHistogram() {
        return histogram;
    }
    
    public void println(String prefix) {
        System.out.println(prefix + toString());
    }
    
    public void println(String prefix, String postfix) {
        System.out.println(prefix + toString() + postfix);
    }
    
}
