package de.dfki.sds.mschroeder.commons.lang.swing;

import java.awt.Dimension;
import java.awt.Frame;
import javax.swing.JPanel;

/**
 * A dialog that shows an acquisition panel.
 * @author Markus Schr&ouml;der
 */
public class PanelDialog extends javax.swing.JDialog {

    private JPanel panel;
    
    public PanelDialog(JPanel panel, Dimension size) {
        super((Frame) null, true);
        this.panel = panel;
        initComponents();
        getContentPane().add(panel, java.awt.BorderLayout.CENTER);
        
        setSize(size);
        setPreferredSize(size);
        
        pack();
        setLocationRelativeTo(null);
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void showGUI(JPanel panel) {
        //1920x1080
        showGUI(panel, 1600, 1000);
    }
    
    public static void showGUI(JPanel panel, int width, int height) {
        PanelDialog dialog = new PanelDialog(panel, new Dimension(width, height));
        dialog.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(java.awt.event.WindowEvent e) {
                dialog.dispose();
            }
        });
        dialog.setVisible(true); //this blocks (would not if invokeLater is used)
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
