package de.dfki.sds.mschroeder.commons.lang.swing;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.WindowEvent;
import java.util.function.Consumer;
import javax.swing.JPanel;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class PanelFrame extends javax.swing.JFrame {

    private JPanel panel;
    private Consumer<WindowEvent> closingConsumer;
    
    public PanelFrame(String title, JPanel panel, Point location, Dimension size, Consumer<WindowEvent> closingConsumer) {
        initComponents();
        
        this.setTitle(title);
        
        this.panel = panel;
        this.closingConsumer = closingConsumer;
        
        getContentPane().add(panel, java.awt.BorderLayout.CENTER);
        
        setSize(size);
        setPreferredSize(size);
        
        pack();
        
        if(location == null) {
            setLocationRelativeTo(null);
        } else {
            setLocation(location);
        }
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        if(closingConsumer != null) {
            closingConsumer.accept(evt);
        }
    }//GEN-LAST:event_formWindowClosing

    public static PanelFrame showGUI(String title, JPanel panel, Point location, Dimension size, Consumer<WindowEvent> closingConsumer) {
        PanelFrame frame = new PanelFrame(title, panel, location, size, closingConsumer);
        java.awt.EventQueue.invokeLater(() -> {
            frame.setVisible(true);
        });
        return frame;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
